<template>
  <div class="sw-gs-offcanvas-product sf-collected-product">
    <div class="sw-gs-offcanvas-product-image-wrapper">
      <div>
        <slot name="image" v-bind="{ image, title }">
          <SwImage
            :src="image"
            :alt="title"
            :width="imageWidth"
            :height="imageHeight"
            class="sw-gs-offcanvas-product-image"
            @click.native="!isSelfService ? openQuickViewModal() : null"
          />
        </slot>
      </div>
      <slot name="input">
        <div v-if="isClient || (isGuide && currentClientCartPermissions)"
             class="sw-gs-offcanvas-product-add-to-cart-btn-wrapper">
          <SwGsAddToCartBtn
            :title="title"
            :product="product"
          />
        </div>
        <div v-if="isClient || (isGuide && currentClientCartPermissions)"
             class="sw-gs-offcanvas-product-quantity-wrapper sf-collected-product__quantity-wrapper">
          <SwQuantitySelector
            :disabled="disableQuantitySelector"
            :qty="qty"
            class="sw-gs-offcanvas-product-quantity-selector sf-collected-product__quantity-selector"
            @input="$emit('input', $event)"
          />
        </div>
      </slot>
    </div>

    <div @click="!isSelfService ? openQuickViewModal() : null">
      <div class="sw-gs-offcanvas-product-details sf-collected-product__details">
        <slot name="title" v-bind="{ title }">
          <div class="sw-gs-offcanvas-product-title-wrapper sf-collected-product__title-wraper">
            <div class="sw-gs-offcanvas-product-title sf-collected-product__title">
              {{ title }}
            </div>
          </div>
        </slot>

        <div class="sw-gs-offcanvas-product-price-container">
          <slot name="price" v-bind="{ specialPrice, regularPrice }">
            <SfPrice
              v-if="regularPrice"
              :regular="regularPrice"
              :special="specialPrice"
            />
          </slot>
          <slot name="remove" v-bind="{ removeHandler }">
            <SwButton
              v-if="isClient || (isGuide && currentClientCartPermissions)"
              class="sf-button--text sf-collected-product__remove sf-collected-product__remove--text js-product-remove-text"
              @click.stop="removeHandler"
            >
              {{ $t("Remove product") }}
            </SwButton>
          </slot>
        </div>
      </div>
    </div>

    <slot name="remove" v-bind="{ removeHandler }">
      <SfCircleIcon
        v-if="isClient || (isGuide && currentClientCartPermissions)"
        icon="cross"
        aria-label="Remove"
        class="sf-circle-icon--small sf-collected-product__remove sf-collected-product__remove--circle-icon"
        @click="removeHandler"
      />
    </slot>
  </div>
</template>

<script>
  import {
    SfPrice,
    SfCircleIcon,
    SfQuantitySelector,
  } from "@storefront-ui/vue"
  import SwImage from "@/components/atoms/SwImage.vue"
  import SwGsAddToCartBtn from "../SwGsAddToCartBtn.vue";
  import SwButton from "@/components/atoms/SwButton.vue"
  import {useGsCart} from "../../logic/composables/useGsCart";
  import {useQuickView} from "../../logic/composables/useQuickView";
  import {useAppointment} from "../../logic/composables/useAppointment";
  import {toRefs} from "@vue/composition-api"
  import SwQuantitySelector from "../SwQuantitySelector.vue";

  export default {
    name: "SwGsOffcanvasProduct",
    components: {
      SwButton,
      SwImage,
      SfCircleIcon,
      SfPrice,
      SfQuantitySelector,
      SwGsAddToCartBtn,
      SwQuantitySelector,
    },
    model: {
      prop: "qty",
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
      image: {
        type: String,
        default: "",
      },
      disableQuantitySelector: {
        type: Boolean,
        default: false,
      },
      imageWidth: {
        type: [String, Number],
        default: 140,
      },
      imageHeight: {
        type: [String, Number],
        default: 200,
      },
      title: {
        type: String,
        default: "",
      },
      regularPrice: {
        type: [Number, String],
        default: null,
      },
      specialPrice: {
        type: [Number, String],
        default: null,
      },
      qty: {
        type: [Number, String],
        default: 1,
      }
    },
    setup(props, {}) {
      const { product } = toRefs(props);
      const { isGuide, isClient } = useAppointment();
      const { currentClientCartPermissions } = useGsCart();
      const { openQuickView } = useQuickView();
      const { isSelfService } = useAppointment();

      function openQuickViewModal() {
          openQuickView(product.value);
      }

      return {
        isGuide,
        isClient,
        currentClientCartPermissions,
        isSelfService,
        openQuickViewModal
      }
    },
    methods: {
      removeHandler() {
        this.$emit("click:remove");
      }
    },
  }
</script>
<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-offcanvas-product {
    flex-wrap: wrap;
    margin: 0 8px;
    padding: var(--spacer-sm) var(--spacer-2xs);

    &:hover {
      cursor: pointer;
      @include for-desktop {
        .sf-collected-product__remove {
          --collected-product-remove-opacity: 1;
        }
      }
      &:after {
        z-index: -1;
      }
    }

    &:after {
      transition: all 0.2s ease-out;
      position: absolute;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      z-index: 1;
    }
  }
  .sw-gs-offcanvas-product-image-wrapper {
    position: relative;
    width: 100%;
  }

  .sw-gs-offcanvas-product-image {
    min-height: 210px;
    width: 100%;
  }

  .sw-gs-offcanvas-product-quantity-wrapper {
    position: absolute;
    right: auto;
    left: 50%;
    padding: 0;
    bottom: var(--spacer-sm);
    transform: translateX(-50%);
  }

  .sw-gs-offcanvas-product-add-to-cart-btn-wrapper {
    position: absolute;
    right: var(--spacer-2xs);
    bottom: 0;
  }

  .sw-gs-offcanvas-product-quantity-selector {
    background: var(--c-white);
    height: 40px;

    ::v-deep .sf-input__wrapper input {
      padding-top: 0;
    }
  }

  .sw-gs-offcanvas-product-title {
    text-overflow: ellipsis;
    display: -webkit-box;
    overflow: hidden;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;
    height: 50px;
    margin: 0;
  }

  .sf-collected-product__remove--circle-icon {
    top: 0;
  }

  .sw-gs-offcanvas-product-price-container {
    position: relative;

    .sf-collected-product__remove--text {
      font-size: var(--font-size--xs);
      height: 100%;
      top: 50%;
      right: 0;
      transform: translateY(-50%);
    }
  }

  .sf-price__regular {
    font-weight: normal;
  }
</style>
